<?php
// $Id $

function cmlservice_admin_settings() {
/*  
  $form['general']['cmlservice_verbose'] = array(
    '#type' => 'checkbox',
    '#title' => t('Verbose'),
    '#default_value' =>  FALSE,
    '#description' => t('Display alias changes (except during bulk updates).'),
  );
  return system_settings_form($form);
  */
}

function cmlservice_form($form_state){
    $abort = FALSE;
    $processing = array();
    $system_path = variable_get('cml_data_path', drupal_get_path('module', 'cmlservice'));
    if(!is_dir("$system_path")){ 
      $processing[] ='Can`t find the cml directory. Please select it '.l('here', 'admin/store/settings/cml'); $abort = TRUE;
    }
    $is_import_file = TRUE;
    if(!is_file("$system_path/import.xml")){ 
      $processing[] ='There is no import file.';
      $is_import_file = FALSE;
    }
    $is_offers_file = TRUE;
    if(!is_file("$system_path/offers.xml")){ 
      $processing[] ='There is no offers file.';
      $is_offers_file = FALSE;
    }
    if(!$is_import_file){ 
      
      $processing[]='<b style=color:red>No more tasks to continue.</b>';
      $abort = TRUE;
      
    }else{
        
      $options = array(); $options_set = array();
      $flags = cmlservice_get_flags();
      
      $options = cmlservice_plugins();
      
      foreach($flags as $flag){
        switch($flag){
          case 'delete_all':
            $processing[] = '<b style=color:red>Attention!!!</b> Will delete all products` data.'; 
            $options_set[$flag] = TRUE;
          break;
          case '1c_attention':
            $processing[] ='Can`t run it because the 1c proceaa aren`t finish.'; $abort = TRUE;
          break;
          case 'drupal_attention':
            $processing[] ='Can`t run it because another process are running.'; $abort = TRUE;
          break;
          case 'update_all':
            $processing[] = 'Will be updated all.'; 
            $options_set[$flag] = TRUE;
          break;        
          case 'update_price':
            $processing[] = 'Will be updated only price.'; 
            $options_set[$flag] = TRUE;
          break;
          case 'update_title':
            $processing[] = 'Will be updated product title.'; 
            //$options['update_title'] = t('Updated title.'); 
            $options_set[$flag] = TRUE;
          break;
          case 'update_description':
            $processing[] = 'Will be updated product description.'; 
            //$options['update_description'] = t('Updated description.'); 
            $options_set[$flag] = TRUE;
          break;
          case 'update_picture':
              $processing[] = 'Will be updated product pictures.'; 
              //$options['update_picture'] = t('Updated pictures.'); 
              $options_set[$flag] = TRUE;
          break;          
          case 'update_price':
            if($is_offers_file){
              $processing[] = 'Will be updated price.'; 
              //$options['update_price'] = t('Updated price list.'); 
              $options_set[$flag] = TRUE;
            }
          break;                                                                    
        }
      }
      
    }
    
    if(!is_dir("$system_path/import_files")){
      $processing[] = '<b style="color:red">There is no pictures.</b>';
    }
    
    if(isset($options_set))  
    $form['flags'] = array(
      '#type' => 'checkboxes',
      '#title' => t(''),
      '#default_value' => array_keys($options_set),
      '#options' => $options,
      //'#disabled' => TRUE,
    );
    $form['processing'] = array(
      '#type' => 'item',
      '#title' => 'ver: ' . CML_VER,
      '#value' => $processing ? implode("<br>", $processing) : '',
    );    
    if($abort) return $form;
    
    $form['submit'] = array(
      '#type' => 'submit',
      '#value' => t('Submit'),
    );
    
  return $form;
}

function cmlservice_form_submit($form, &$form_state) {
  cmlservice_add($form_state['values']);
}

function cmlservice_page() {
  $output = drupal_get_form('cmlservice_form');
  return $output;
}

function cml_settings(){
  $output = drupal_get_form('cml_settings_form');
  return $output;
}

function cml_settings_form(&$form_state){
  $form['cml_data_path'] = array(
    '#type' => 'textfield',
    '#title' => t('Path to folder'),
    '#description' => t('Path must be without /import_files'),
    '#default_value' =>  variable_get('cml_data_path', drupal_get_path('module', 'cmlservice') . '/import_files'),
  );
  $form['cml_product_altered_price'] = array(
    '#type' => 'checkbox',
    '#title' => t('Altered price on/off'),
    '#default_value' => variable_get('cml_product_altered_price', FALSE),
    '#description' => t(''),
  );  
  $form['Order user info'] = array(
     '#type' => 'fieldset',
     '#title' => t('Order user info'),
     '#collapsible' => TRUE,
     '#collapsed' => FALSE,
  );  
  $form['Order user info']['cml_order_user_info'] = array(
    '#title' => t('Order info'),
    '#type' => 'radios',
    '#default_value' => variable_get('cml_order_user_info', 0),
    '#options' => array(
      0 => t('Use billing data for order'), // Платежной информации
      1 => t('Use delivery data for order'), // Информации о доставки
    ),
  );
  
  $form['cml_product_format'] = filter_form(
    variable_get('cml_product_format', FILTER_FORMAT_DEFAULT) ,NULL , array('cml_product_format'));  
  $form['cml_product_format']['#collapsed'] = FALSE;
         
  $form = system_settings_form($form);
  
  return $form;
}